/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-02 17:12
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int SOURCE = 0;
const int SINK = 1;
const int JOE = 2;
const int HEROOFFSET = 3;
const int MONSTEROFFSET = HEROOFFSET + 500 + 4;
int hero(int i){ return HEROOFFSET + i; }
int monster(int i){ return MONSTEROFFSET + i; }

const ll MAXN = MONSTEROFFSET + 500 + 9;

// dinic - from reference
const int INF = 1 << 30;
struct edge {
  int v, w, c, f;
};
vector<edge> edgelist;
vector<int> edgeind[MAXN], ptr, dis;
int s, t;
void addedge(int v, int w, int c) {
  /* fprintf(stderr, "constructing edges: %4d -> %4d with cap %d\n", v, w, c); */
  edgeind[v].push_back(edgelist.size());
  edgelist.push_back({v, w, c, 0});
  edgeind[w].push_back(edgelist.size());
  edgelist.push_back({w, v, 0, 0});
}
bool bfs_din() {
  dis.assign(MAXN, -1);
  dis[s] = 0;
  queue<int> q({s});
  while (!q.empty() && dis[t] == -1) {
    int v = q.front(); q.pop();
    for (int ei : edgeind[v]) {
      edge e = edgelist[ei];
      if (dis[e.w] == -1 && e.f < e.c) {
        q.push(e.w);
        dis[e.w] = dis[v] + 1;
      }
    }
  }
  return dis[t] != -1;
}
int dfs_din(int v = s, int mf = INF) {
  if (!mf || v == t)
    return mf;
  for (;ptr[v] < ssize(edgeind[v]); ptr[v]++) {
    int ei = edgeind[v][ptr[v]];
    edge e = edgelist[ei];
    if (dis[e.w] != dis[v] + 1)
      continue;
    int tf = dfs_din(e.w, min(mf, e.c-e.f));
    if (tf) {
      edgelist[ei].f += tf;
      edgelist[ei ^ 1].f -= tf;
      return tf;
    }
  }
  return 0;
}
ll dinic() {
  ll flow = 0;
  while (1) {
    if (!bfs_din()) break;
    ptr.assign(MAXN, 0);
    while (int tf = dfs_din()){
      flow += tf;
    }
  }
  return flow;
}


ll H, M, K;

void solve(){
    // Code goes here ...
    cin >> H >> M >> K;

    int num, m;
    R(h, H){
        cin >> num;
        R(i, num){
            cin >> m;
            addedge(hero(h), monster(m), 1);
        }
    }

    R(h, H) addedge(SOURCE, hero(h), 1);
    R(m, M+1) addedge(monster(m), SINK, 1);
    addedge(SOURCE, JOE, K);
    R(h, H) addedge(JOE, hero(h), 1);

    s = SOURCE;
    t = SINK;
    ll res = dinic();

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
